<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>python</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<p>Basics PEP8 : Python Enhancement Proposals, style-guide for Python.</p>
<p>print is the equivalent of console.log.</p>
<h1 id="is-used-to-make-comments-in-your-code.">is used to make comments in your code.</h1>
<p>def foo(): """ The foo function does many amazing things that you should not question. Just accept that it exists and use it with caution. """ secretThing()</p>
<p>Python has a built in help function that let’s you see a description of the source code without having to navigate to it.</p>
<p>Numbers Python has three types of numbers:</p>
<p>Integer</p>
<p>Positive and Negative Counting Numbers. No Decimal Point Created by a literal non-decimal pt number or with the int() constructor.</p>
<p>print(3) # =&gt; 3 print(int(19)) # =&gt; 19 print(int()) # =&gt; 0</p>
<p>Boolean is a subtype of integer in Python.</p>
<p>Floating Point Number</p>
<p>Decimal Numbers.</p>
<p>print(2.24) # =&gt; 2.24 print(2.) # =&gt; 2.0 print(float()) # =&gt; 0.0 print(27e-5) # =&gt; 0.00027</p>
<p>Complex Numbers</p>
<p>Consist of a real part and imaginary part. The i is switched to a j in programming.</p>
<p>print(7j) # =&gt; 7j print(5.1+7.7j)) # =&gt; 5.1+7.7j print(complex(3, 5)) # =&gt; 3+5j print(complex(17)) # =&gt; 17+0j print(complex()) # =&gt; 0j</p>
<p>Type Casting : The process of converting one number to another.</p>
<p>Using Float print(17) # =&gt; 17 print(float(17)) # =&gt; 17.0</p>
<p>Using Int print(17.0) # =&gt; 17.0 print(int(17.0)) # =&gt; 17</p>
<p>Using Str print(str(17.0) + ’ and ’ + str(17)) # =&gt; 17.0 and 17</p>
<p>The arithmetic operators are the same between JS and Python, with two additions:</p>
<p>“**” : Double asterisk for exponent. “//” : Integer Division. There are no spaces between math operations in Python.</p>
<p>Integer Division gives the other part of the number from Module; it is a way to do round down numbers replacing Math.floor() in JS.</p>
<p>There are no ++ and – in Python, the only shorthand operators are: pic pic Strings Python uses both single and double quotes.</p>
<p>You can escape strings like so ‘Jodi asked, “What's up, Sam?”’</p>
<p>Multiline strings use triple quotes.</p>
<p>print(’‘’My instructions are very long so to make them more readable in the code I am putting them on more than one line. I can even include “quotes” of any kind because they won’t get confused with the end of the string!’’’)</p>
<p>Use the len() function to get the length of a string.</p>
<p>print(len(“Spaghetti”)) # =&gt; 9 Python uses zero-based indexing Python allows negative indexing (thank god!)</p>
<p>print(“Spaghetti”[-1]) # =&gt; i print(“Spaghetti”[-4]) # =&gt; e Python let’s you use ranges</p>
<p>print(“Spaghetti”[1:4]) # =&gt; pag print(“Spaghetti”[4:-1]) # =&gt; hett print(“Spaghetti”[4:4]) # =&gt; (empty string) The end range is exclusive just like slice in JS. Shortcut to get from the beginning of a string to a certain index. print(“Spaghetti”[:4]) # =&gt; Spag print(“Spaghetti”[:-1]) # =&gt; Spaghett</p>
<p>Shortcut to get from a certain index to the end of a string. print(“Spaghetti”[1:]) # =&gt; paghetti print(“Spaghetti”[-4:]) # =&gt; etti</p>
<p>The index string function is the equiv. of indexOf() in JS</p>
<p>print(“Spaghetti”.index(“h”)) # =&gt; 4 print(“Spaghetti”.index(“t”)) # =&gt; 6</p>
<p>The count function finds out how many times a substring appears in a string.</p>
<p>print(“Spaghetti”.count(“h”)) # =&gt; 1 print(“Spaghetti”.count(“t”)) # =&gt; 2 print(“Spaghetti”.count(“s”)) # =&gt; 0 print(’‘’We choose to go to the moon in this decade and do the other things, not because they are easy, but because they are hard, because that goal will serve to organize and measure the best of our energies and skills, because that challenge is one that we are willing to accept, one we are unwilling to postpone, and one which we intend to win, and the others, too.’’‘.count(’the’)) # =&gt; 4</p>
<p>You can use + to concatenate strings, just like in JS.</p>
<p>You can also use “*” to repeat strings or multiply strings.</p>
<p>Use the format() function to use placeholders in a string to input values later on.</p>
<p>first_name = “Billy” last_name = “Bob” print(‘Your name is {0} {1}’.format(first_name, last_name)) # =&gt; Your name is Billy Bob</p>
<p>Shorthand way to use format function is: print(f’Your name is {first_name} {last_name}’)</p>
<p>Some useful string methods.</p>
<p>Note that in JS join is used on an Array, in Python it is used on String. pic There are also many handy testing methods. pic</p>
<p>Variables and Expressions Duck-Typing : Programming Style which avoids checking an object’s type to figure out what it can do.</p>
<p>Duck Typing is the fundamental approach of Python. Assignment of a value automatically declares.</p>
<p>a = 7 b = ‘Marbles’ print(a) # =&gt; 7 print(b) # =&gt; Marbles</p>
<p>You can chain variable assignments to give multiple var names the same value.</p>
<p>Use with caution as this is highly unreadable count = max = min = 0 print(count) # =&gt; 0 print(max) # =&gt; 0 print(min) # =&gt; 0</p>
<p>The value and type of a variable can be re-assigned at any time.</p>
<p>a = 17 print(a) # =&gt; 17 a = ‘seventeen’ print(a) # =&gt; seventeen</p>
<p>NaN does not exist in Python, but you can ‘create’ it like so: print(float(“nan”))</p>
<p>Python replaces null with none. none is an object and can be directly assigned to a variable. Using none is a convenient way to check to see why an action may not be operating correctly in your program. Boolean Data Type One of the biggest benefits of Python is that it reads more like English than JS does. pic</p>
<p>Logical AND print(True and True) # =&gt; True print(True and False) # =&gt; False print(False and False) # =&gt; False</p>
<p>Logical OR print(True or True) # =&gt; True print(True or False) # =&gt; True print(False or False) # =&gt; False</p>
<p>Logical NOT print(not True) # =&gt; False print(not False and True) # =&gt; True print(not True or False) # =&gt; False</p>
<p>By default, Python considers an object to be true UNLESS it is one of the following:</p>
<p>Constant None or False Zero of any numeric type. Empty Sequence or Collection. True and False must be capitalized</p>
<p>Comparison Operators Python uses all the same equality operators as JS.</p>
<p>In Python, equality operators are processed from left to right.</p>
<p>Logical operators are processed in this order:</p>
<p>NOT AND OR Just like in JS, you can use parentheses to change the inherent order of operations.</p>
<p>Short Circuit : Stopping a program when a true or false has been reached. pic</p>
<p>Identity vs Equality print (2 == ‘2’) # =&gt; False print (2 is ‘2’) # =&gt; False</p>
<p>print (“2” == ‘2’) # =&gt; True print (“2” is ‘2’) # =&gt; True</p>
<h1 id="there-is-a-distinction-between-the-number-types.">There is a distinction between the number types.</h1>
<p>print (2 == 2.0) # =&gt; True print (2 is 2.0) # =&gt; False In the Python community it is better to use is and is not over == or != If Statements if name == ‘Monica’: print(‘Hi, Monica.’)</p>
<p>if name == ‘Monica’: print(‘Hi, Monica.’) else: print(‘Hello, stranger.’)</p>
<p>if name == ‘Monica’: print(‘Hi, Monica.’) elif age &lt; 12: print(‘You are not Monica, kiddo.’) elif age &gt; 2000: print(‘Unlike you, Monica is not an undead, immortal vampire.’) elif age &gt; 100: print(‘You are not Monica, grannie.’) Remember the order of elif statements matter. While Statements spam = 0 while spam &lt; 5: print(‘Hello, world.’) spam = spam + 1 Break statement also exists in Python.</p>
<p>spam = 0 while True: print(‘Hello, world.’) spam = spam + 1 if spam &gt;= 5: break</p>
<p>As are continue statements</p>
<p>spam = 0 while True: print(‘Hello, world.’) spam = spam + 1 if spam &lt; 5: continue break</p>
<p>Try/Except Statements Python equivalent to try/catch</p>
<p>a = 321 try: print(len(a)) except: print(‘Silently handle error here’)</p>
<h1 id="optionally-include-a-correction-to-the-issue">Optionally include a correction to the issue</h1>
<p>a = str(a) print(len(a) a = ‘321’ try: print(len(a)) except: print(‘Silently handle error here’)</p>
<h1 id="optionally-include-a-correction-to-the-issue-1">Optionally include a correction to the issue</h1>
<p>a = str(a) print(len(a)) You can name an error to give the output more specificity.</p>
<p>a = 100 b = 0 try: c = a / b except ZeroDivisionError: c = None print(c)</p>
<p>You can also use the pass commmand to by pass a certain error.</p>
<p>a = 100 b = 0 try: print(a / b) except ZeroDivisionError: pass</p>
<p>The pass method won’t allow you to bypass every single error so you can chain an exception series like so:</p>
<p>a = 100</p>
<p>b = “5” try: print(a / b) except ZeroDivisionError: pass except (TypeError, NameError): print(“ERROR!”)</p>
<p>You can use an else statement to end a chain of except statements.</p>
<p>tuple of file names files = (‘one.txt’, ‘two.txt’, ‘three.txt’)</p>
<p>simple loop for filename in files: try: # open the file in read mode f = open(filename, ‘r’) except OSError: # handle the case where file does not exist or permission is denied print(‘cannot open file’, filename) else: # do stuff with the file object (f) print(filename, ‘opened successfully’) print(‘found’, len(f.readlines()), ‘lines’) f.close()</p>
<p>finally is used at the end to clean up all actions under any circumstance.</p>
<p>def divide(x, y): try: result = x / y except ZeroDivisionError: print(“Cannot divide by zero”) else: print(“Result is”, result) finally: print(“Finally…”)</p>
<p>Using duck typing to check to see if some value is able to use a certain method.</p>
<p>Try a number - nothing will print out a = 321 if hasattr(a, ‘len’): print(len(a))</p>
<p>Try a string - the length will print out (4 in this case) b = “5555” if hasattr(b, ‘len’): print(len(b))</p>
<p>Pass Pass Keyword is required to write the JS equivalent of :</p>
<p>if (true) { }</p>
<p>while (true) {}</p>
<p>if True: pass</p>
<p>while True: pass</p>
<p>Functions Function definition includes:</p>
<p>The def keyword The name of the function A list of parameters enclosed in parentheses. A colon at the end of the line. One tab indentation for the code to run. You can use default parameters just like in JS</p>
<p>def greeting(name, saying=“Hello”): print(saying, name)</p>
<p>greeting(“Monica”)</p>
<p>Hello Monica greeting(“Barry”, “Hey”)</p>
<p>Hey Barry Keep in mind, default parameters must always come after regular parameters.</p>
<p>THIS IS BAD CODE AND WILL NOT RUN def increment(delta=1, value): return delta + value</p>
<p>You can specify arguments by name without destructuring in Python.</p>
<p>def greeting(name, saying=“Hello”): print(saying, name)</p>
<p>name has no default value, so just provide the value saying has a default value, so use a keyword argument greeting(“Monica”, saying=“Hi”)</p>
<p>The lambda keyword is used to create anonymous functions and are supposed to be one-liners.</p>
<p>toUpper = lambda s: s.upper()</p>
<p>Notes Formatted Strings Remember that in Python join() is called on a string with an array/list passed in as the argument. shopping_list = [‘bread’,‘milk’,‘eggs’] print(‘,’.join(shopping_list)) Python has a very powerful formatting engine. format() is also applied directly to strings.</p>
<p>Comma Thousands Separator print(‘{:,}’.format(1234567890)) ‘1,234,567,890’</p>
<p>Date and Time d = datetime.datetime(2020, 7, 4, 12, 15, 58) print(‘{:%Y-%m-%d %H:%M:%S}’.format(d)) ‘2020-07-04 12:15:58’</p>
<p>Percentage points = 190 total = 220 print(‘Correct answers: {:.2%}’.format(points/total)) Correct answers: 86.36%</p>
<p>Data Tables width=8 print(’ decimal hex binary’) print(‘-’*27) for num in range(1,16): for base in ‘dXb’: print(‘{0:{width}{base}}’.format(num, base=base, width=width), end=’ ‘) print() Getting Input from the Command Line Python runs synchronously, all programs and processes will stop when listening for a user input. The input function shows a prompt to a user and waits for them to type ’ENTER’. Scripts vs Programs Programming Script : A set of code that runs in a linear fashion. The largest difference between scripts and programs is the level of complexity and purpose. Programs typically have many UI’s.</p>
<p>Python can be used to display html, css, and JS. We will be using Python as an API (Application Programming Interface)</p>
<p>Structured Data Sequence : The most basic data structure in Python where the index determines the order.</p>
<p>List Tuple Range Collections : Unordered data structures, hashable values.</p>
<p>Dictionaries Sets Iterable : Generic name for a sequence or collection; any object that can be iterated through. Can be mutable or immutable. Built In Data Types Lists are the python equivalent of arrays. empty_list = [] departments = [‘HR’,‘Development’,‘Sales’,‘Finance’,‘IT’,‘Customer Support’]</p>
<p>You can instantiate specials = list()</p>
<p>Test if a value is in a list. print(1 in [1, 2, 3]) #&gt; True print(4 in [1, 2, 3]) #&gt; False Tuples : Very similar to lists, but they are immutable</p>
<p>Instantiated with parentheses time_blocks = (‘AM’,‘PM’)</p>
<p>Sometimes instantiated without colors = ‘red’,‘blue’,‘green’ numbers = 1, 2, 3</p>
<p>Tuple() built in can be used to convert other data into a tuple tuple(‘abc’) # returns (‘a’, ‘b’, ‘c’) tuple([1,2,3]) # returns (1, 2, 3) Think of tuples as constant variables.</p>
<p>Ranges : A list of numbers which can’t be changed; often used with for loops. Declared using one to three parameters. Start : opt. default 0, first # in sequence. Stop : required next number past the last number in the sequence. Step : opt. default 1, difference between each number in the sequence. range(5) # [0, 1, 2, 3, 4] range(1,5) # [1, 2, 3, 4] range(0, 25, 5) # [0, 5, 10, 15, 20] range(0) # [ ] for let (i = 0; i &lt; 5; i++) for let (i = 1; i &lt; 5; i++) for let (i = 0; i &lt; 25; i+=5) for let(i = 0; i = 0; i++) Keep in mind that stop is not included in the range.</p>
<p>Dictionaries : Mappable collection where a hashable value is used as a key to ref. an object stored in the dictionary. Mutable. a = {‘one’:1, ‘two’:2, ‘three’:3} b = dict(one=1, two=2, three=3) c = dict([(‘two’, 2), (‘one’, 1), (‘three’, 3)]) a, b, and c are all equal</p>
<p>Declared with curly braces of the built in dict()</p>
<p>Benefit of dictionaries in Python is that it doesn’t matter how it is defined, if the keys and values are the same the dictionaries are considered equal.</p>
<p>Use the in operator to see if a key exists in a dictionary.</p>
<p>Sets : Unordered collection of distinct objects; objects that need to be hashable.</p>
<p>Always be unique, duplicate items are auto dropped from the set. Common Uses: Removing Duplicates Membership Testing Mathematical Operators: Intersection, Union, Difference, Symmetric Difference. Standard Set is mutable, Python has a immutable version called frozenset. Sets created by putting comma seperated values inside braces:</p>
<p>school_bag = {‘book’,‘paper’,‘pencil’,‘pencil’,‘book’,‘book’,‘book’,‘eraser’} print(school_bag)</p>
<p>Also can use set constructor to automatically put it into a set. letters = set(‘abracadabra’) print(letters) Built-In Functions Functions using iterables</p>
<p>filter(function, iterable) : creates new iterable of the same type which includes each item for which the function returns true.</p>
<p>map(function, iterable) : creates new iterable of the same type which includes the result of calling the function on every item of the iterable.</p>
<p>sorted(iterable, key=None, reverse=False) : creates a new sorted list from the items in the iterable.</p>
<p>Output is always a list key: opt function which coverts and item to a value to be compared. reverse: optional boolean. enumerate(iterable, start=0) : starts with a sequence and converts it to a series of tuples</p>
<p>quarters = [‘First’, ‘Second’, ‘Third’, ‘Fourth’] print(enumerate(quarters)) print(enumerate(quarters, start=1))</p>
<p>(0, ‘First’), (1, ‘Second’), (2, ‘Third’), (3, ‘Fourth’) (1, ‘First’), (2, ‘Second’), (3, ‘Third’), (4, ‘Fourth’) zip(*iterables) : creates a zip object filled with tuples that combine 1 to 1 the items in each provided iterable. Functions that analyze iterables</p>
<p>len(iterable) : returns the count of the number of items.</p>
<p>max(*args, key=None) : returns the largest of two or more arguments.</p>
<p>max(iterable, key=None) : returns the largest item in the iterable.</p>
<p>key optional function which converts an item to a value to be compared. min works the same way as max</p>
<p>sum(iterable) : used with a list of numbers to generate the total.</p>
<p>There is a faster way to concatenate an array of strings into one string, so do not use sum for that. any(iterable) : returns True if any items in the iterable are true.</p>
<p>all(iterable) : returns True is all items in the iterable are true.</p>
<p>Working with dictionaries</p>
<p>dir(dictionary) : returns the list of keys in the dictionary. Working with sets</p>
<p>Union : The pipe | operator or union(*sets) function can be used to produce a new set which is a combination of all elements in the provided set. a = {1, 2, 3} b = {2, 4, 6} print(a | b) # =&gt; {1, 2, 3, 4, 6} Intersection : The &amp; operator ca be used to produce a new set of only the elements that appear in all sets. a = {1, 2, 3} b = {2, 4, 6} print(a &amp; b) # =&gt; {2} Difference : The - operator can be used to produce a new set of only the elements that appear in the first set and NOT the others.</p>
<p>Symmetric Difference : The ^ operator can be used to produce a new set of only the elements that appear in exactly one set and not in both.</p>
<p>a = {1, 2, 3} b = {2, 4, 6} print(a - b) # =&gt; {1, 3} print(b - a) # =&gt; {4, 6} print(a ^ b) # =&gt; {1, 3, 4, 6} For Statements In python, there is only one for loop.</p>
<p>Always Includes: The for keyword A variable name The in keyword An iterable of some kid A colon On the next line, an indented block of code called the for clause. You can use break and continue statements inside for loops as well.</p>
<p>You can use the range function as the iterable for the for loop.</p>
<p>print(‘My name is’) for i in range(5): print(‘Carlita Cinco (’ + str(i) + ‘)’)</p>
<p>total = 0 for num in range(101): total += num print(total) Looping over a list in Python for c in [‘a’, ‘b’, ‘c’]: print(c)</p>
<p>lst = [0, 1, 2, 3] for i in lst: print(i) Common technique is to use the len() on a pre-defined list with a for loop to iterate over the indices of the list. supplies = [‘pens’, ‘staplers’, ‘flame-throwers’, ‘binders’] for i in range(len(supplies)): print(‘Index’ + str(i) + ’ in supplies is: ’ + supplies[i]) You can loop and destructure at the same time. l = [[1, 2], [3, 4], [5, 6]] for a, b in l: print(a, ‘,’, b)</p>
<p>Prints 1, 2 Prints 3, 4 Prints 5, 6 You can use values() and keys() to loop over dictionaries. spam = {‘color’: ‘red’, ‘age’: 42} for v in spam.values(): print(v)</p>
<p>Prints red Prints 42 for k in spam.keys(): print(k)</p>
<p>Prints color Prints age For loops can also iterate over both keys and values.</p>
<p>Getting tuples for i in spam.items(): print(i)</p>
<p>Prints (‘color’, ‘red’) Prints (‘age’, 42) Destructuring to values for k, v in spam.items(): print(‘Key:’ + k + ’ Value: ’ + str(v))</p>
<p>Prints Key: age Value: 42 Prints Key: color Value: red Looping over string for c in “abcdefg”: print(c) More On Functions Variable-length positional arguments : (args) def add(a, b, args): total = a + b; for n in args: total += n return total</p>
<p>add(1, 2) # Returns 3</p>
<p>add(2, 3, 4, 5) # Returns 14 keyword arguments : (*kwargs) def print_names_and_countries(greeting, **kwargs): for k, v in kwargs.items(): print(greeting, k, “from”, v)</p>
<p>print_names_and_countries(“Hi”, Monica=“Sweden”, Charles=“British Virgin Islands”, Carlo=“Portugal”)</p>
<p>Prints Hi Monica from Sweden Hi Charles from British Virgin Islands Hi Carlo from Portugal When you order arguments within a function or function call, the args need to occur in a particular order: formal positional args. args keyword args with default values <strong>kwargs def example(arg_1, arg_2, args, </strong>kwargs): pass</p>
<p>def example2(arg_1, arg_2, *args, kw_1=“shark”, kw_2=“blowfish”, **kwargs): pass Importing in Python Modules are similar to packages in Node.js Come in different types: Built-In, Third-Party, Custom. All loaded using import statements. Terms</p>
<p>module : Python code in a separate file. package : Path to a directory that contains modules. init.py : Default file for a package. submodule : Another file in a module’s folder. function : Function in a module.</p>
<p>A module can be any file but it is usually created by placing a special file init.py into a folder. pic</p>
<p>Try to avoid importing with wildcards in Python.</p>
<p>Use multiple lines for clarity when importing.</p>
<p>from urllib.request import ( HTTPDefaultErrorHandler as ErrorHandler, HTTPRedirectHandler as RedirectHandler, Request, pathname2url, url2pathname, urlopen, ) Watching Out for Python 2 Python 3 removed &lt;&gt; and only uses !=</p>
<p>format() was introduced with P3 All strings in P3 are unicode and encoded. md5 was removed. ConfigParser was renamed to configparser sets were killed in favor of set() class.</p>
<p>print was a statement in P2, but is a function in P3.</p>
<p>Topics revisited (in python syntax) def say_hi(name): ""“&lt;—- Multi-Line Comments and Docstrings This is where you put your content for help() to inform the user about what your function does and how to use it”"" print(f“Hello {name}!”)</p>
<p>print(say_hi(“Michael”)) # Should get the print inside the function, then None</p>
<h1 id="boolean-values">Boolean Values</h1>
<h1 id="work-the-same-as-in-js-except-they-are-title-case-true-and-false">Work the same as in JS, except they are title case: True and False</h1>
<p>a = True b = False</p>
<h1 id="logical-operators">Logical Operators</h1>
<h1 id="not-or-and">! = not, || = or, &amp;&amp; = and</h1>
<p>print(True and True) print(True and not True) print(True or True)</p>
<h1 id="truthiness---everything-is-true-except">Truthiness - Everything is True except…</h1>
<h1 id="false---none-false-set-range0">False - None, False, ’’, [], (), set(), range(0)</h1>
<h1 id="number-values">Number Values</h1>
<h1 id="integers-are-numbers-without-a-floating-decimal-point">Integers are numbers without a floating decimal point</h1>
<p>print(type(3)) # type returns the type of whatever argument you pass in # Floating Point values are numbers with a floating decimal point print(type(3.5))</p>
<h1 id="type-casting">Type Casting</h1>
<h1 id="you-can-convert-between-ints-and-floats-along-with-other-types">You can convert between ints and floats (along with other types…)</h1>
<p>print(float(3)) # If you convert a float to an int, it will truncate the decimal print(int(4.5)) print(type(str(3))) # Python does not automatically convert types like JS # print(17.0 + ’ heyooo ’ + 17) # TypeError</p>
<h1 id="arithmetic-operators">Arithmetic Operators</h1>
<h1 id="exponent-comparable-to-math.pownum-pow">** - exponent (comparable to Math.pow(num, pow))</h1>
<h1 id="integer-division">// - integer division</h1>
<h1 id="there-is-no-or-in-python">There is no ++ or – in Python</h1>
<h1 id="string-values">String Values</h1>
<h1 id="we-can-use-single-quotes-double-quotes-or-f-for-string-formats">We can use single quotes, double quotes, or f’’ for string formats</h1>
<h1 id="we-can-use-triple-single-quotes-for-multiline-strings">We can use triple single quotes for multiline strings</h1>
<p>print( ""“This here’s a story All about how My life got twist Turned upside down”"" )</p>
<h1 id="three-double-quotes-can-also-be-used-but-we-typically-reserve-these-for">Three double quotes can also be used, but we typically reserve these for</h1>
<h1 id="multi-line-comments-and-function-docstrings-refer-to-lines-6-9nice-d">multi-line comments and function docstrings (refer to lines 6-9)(Nice :D)</h1>
<h1 id="we-use-len-to-get-the-length-of-something">We use len() to get the length of something</h1>
<p>print(len(“Michael”)) # 7 characters print(len([“hey”, “ho”, “hey”, “hey”, “ho”])) # 5 list items print(len({1, 2, 3, 4, 5, 6, 7, 9})) # 8 set items</p>
<h1 id="we-can-index-into-strings-list-etc..self.">We can index into strings, list, etc..self.</h1>
<p>name = “Michael” for i in range(len(name)): print(name[i]) # M, i, c, h, a, e, l</p>
<h1 id="we-can-index-starting-from-the-end-as-well-with-negatives">We can index starting from the end as well, with negatives</h1>
<p>occupation = “Full Stack Software Engineer” print(occupation[-3]) # e</p>
<h1 id="we-can-also-get-ranges-in-the-index-with-the-startstopstep-syntax">We can also get ranges in the index with the [start:stop:step] syntax</h1>
<p>print(occupation[0:4:1]) # step and stop are optional, stop is exclusive print(occupation[::4]) # beginning to end, every 4th letter print(occupation[4:14:2]) # Let’s get weird with it! # NOTE: Indexing out of range will give you an IndexError</p>
<h1 id="we-can-also-get-the-index-og-things-with-the-.index-method-similar-to-indexof">We can also get the index og things with the .index() method, similar to indexOf()</h1>
<p>print(occupation.index(“Stack”)) print([“Mike”, “Barry”, “Cole”, “James”, “Mark”].index(“Cole”))</p>
<h1 id="we-can-count-how-many-times-a-substringitem-appears-in-something-as-well">We can count how many times a substring/item appears in something as well</h1>
<p>print(occupation.count(“S”)) print( ""“Now this here’s a story all about how My life got twist turned upside down I forget the rest but the the the potato smells like the potato”"“.count(”the" ) )</p>
<h1 id="we-concatenate-the-same-as-javascript-but-we-can-also-multiply-strings">We concatenate the same as Javascript, but we can also multiply strings</h1>
<p>print(“dog” + “show”) print(“ha” * 10)</p>
<h1 id="we-can-use-format-for-a-multitude-of-things-from-spaces-to-decimal-places">We can use format for a multitude of things, from spaces to decimal places</h1>
<p>first_name = “Michael” last_name = “Shuff” print(“Your name is {0} {1}”.format(first_name, last_name))</p>
<h1 id="useful-string-methods">Useful String Methods</h1>
<p>print(“Hello”.upper()) # HELLO print(“Hello”.lower()) # hello print(“HELLO”.islower()) # False print(“HELLO”.isupper()) # True print(“Hello”.startswith(“he”)) # False print(“Hello”.endswith(“lo”)) # True print(“Hello There”.split()) # [Hello, There] print(“hello1”.isalpha()) # False, must consist only of letters print(“hello1”.isalnum()) # True, must consist of only letters and numbers print(“3215235123”.isdecimal()) # True, must be all numbers # True, must consist of only spaces/tabs/newlines print(" “.isspace()) # False, index 0 must be upper case and the rest lower print(”MichaeL“.istitle()) print(”Michael Lee".istitle()) # True!</p>
<h1 id="duck-typing---if-it-walks-like-a-duck-and-talks-like-a-duck-it-must-be-a-duck">Duck Typing - If it walks like a duck, and talks like a duck, it must be a duck</h1>
<h1 id="assignment---all-like-js-but-there-are-no-special-keywords-like-let-or-const">Assignment - All like JS, but there are no special keywords like let or const</h1>
<p>a = 3 b = a c = “heyoo” b = [“reassignment”, “is”, “fine”, “G!”]</p>
<h1 id="comparison-operators---python-uses-the-same-equality-operators-as-js-but-no">Comparison Operators - Python uses the same equality operators as JS, but no ===</h1>
<h1 id="less-than">&lt; - Less than</h1>
<h1 id="greater-than">&gt; - Greater than</h1>
<h1 id="less-than-or-equal">&lt;= - Less than or Equal</h1>
<h1 id="greater-than-or-equal">&gt;= - Greater than or Equal</h1>
<h1 id="equal-to">== - Equal to</h1>
<h1 id="not-equal-to">!= - Not equal to</h1>
<h1 id="is---refers-to-exact-same-memory-location">is - Refers to exact same memory location</h1>
<h1 id="not--">not - !</h1>
<h1 id="precedence---negative-signsnot-are-applied-firstpart-of-each-number">Precedence - Negative Signs(not) are applied first(part of each number)</h1>
<h1 id="multiplication-and-divisionand-happen-next">- Multiplication and Division(and) happen next</h1>
<h1 id="addition-and-subtractionor-are-the-last-step">- Addition and Subtraction(or) are the last step</h1>
<h1 id="note-be-careful-when-using-not-along-with">NOTE: Be careful when using not along with ==</h1>
<p>print(not a == b) # True # print(a == not b) # Syntax Error print(a == (not b)) # This fixes it. Answer: False # Python does short-circuit evaluation</p>
<h1 id="assignment-operators---mostly-the-same-as-js-except-python-has-and-int-division">Assignment Operators - Mostly the same as JS except Python has **= and //= (int division)</h1>
<h1 id="flow-control-statements---if-while-for">Flow Control Statements - if, while, for</h1>
<h1 id="note-python-smushes-else-if-into-elif">Note: Python smushes ‘else if’ into ‘elif’!</h1>
<p>if 10 &lt; 1: print(“We don’t get here”) elif 10 &lt; 5: print(“Nor here…”) else: print(“Hey there!”)</p>
<h1 id="looping-over-a-string">Looping over a string</h1>
<p>for c in “abcdefgh”: print(c)</p>
<h1 id="looping-over-a-range">Looping over a range</h1>
<p>for i in range(5): print(i + 1)</p>
<h1 id="looping-over-a-list">Looping over a list</h1>
<p>lst = [1, 2, 3, 4] for i in lst: print(i)</p>
<h1 id="looping-over-a-dictionary">Looping over a dictionary</h1>
<p>spam = {“color”: “red”, “age”: 42, “items”: [(1, “hey”), (2, “hooo!”)]} for v in spam.values(): print(v)</p>
<h1 id="loop-over-a-list-of-tuples-and-destructuring-the-values">Loop over a list of tuples and destructuring the values</h1>
<h1 id="assuming-spam.items-returns-a-list-of-tuples-each-containing-two-items-k-v">Assuming spam.items returns a list of tuples each containing two items (k, v)</h1>
<p>for k, v in spam.items(): print(f“{k}: {v}”)</p>
<h1 id="while-loops-as-long-as-the-condition-is-true">While loops as long as the condition is True</h1>
<h1 id="exit-loop-early-with-break">- Exit loop early with break</h1>
<h1 id="exit-iteration-early-with-continue">- Exit iteration early with continue</h1>
<p>spam = 0 while True: print(“Heyy girrllll”) spam += 1 if spam &lt; 5: continue break</p>
<h1 id="functions---use-def-keyword-to-define-a-function-in-python">Functions - use def keyword to define a function in Python</h1>
<p>def printCopyright(): print(“Copyright 2020, ya boi, Mike Shuff”)</p>
<h1 id="lambdas-are-one-liners-should-be-at-least-you-can-use-parenthesis-to-disobey">Lambdas are one liners! (Should be at least, you can use parenthesis to disobey)</h1>
<p>avg = lambda num1, num2: print(num1 + num2)</p>
<p>avg(1, 2) # Calling it with keyword arguments, order does not matter avg(num2=20, num1=1252) printCopyright()</p>
<h1 id="we-can-give-parameters-default-arguments-like-js">We can give parameters default arguments like JS</h1>
<p>def greeting(name, saying=“Hello”): print(saying, name)</p>
<p>greeting(“Mike”) # Hello Mike greeting(“Michael”, saying=“Hello there…”)</p>
<h1 id="a-common-gotcha-is-using-a-mutable-object-for-a-default-parameter">A common gotcha is using a mutable object for a default parameter</h1>
<h1 id="all-invocations-of-the-function-reference-the-same-mutable-object">All invocations of the function reference the same mutable object</h1>
<p>def append_item(item_name, item_list=[]): # Will it obey and give us a new list? item_list.append(item_name) return item_list</p>
<h1 id="uses-same-item-list-unless-otherwise-stated-which-is-counterintuitive">Uses same item list unless otherwise stated which is counterintuitive</h1>
<p>print(append_item(“notebook”)) print(append_item(“notebook”)) print(append_item(“notebook”, []))</p>
<h1 id="errors---unlike-js-if-we-pass-the-incorrect-amount-of-arguments-to-a-function">Errors - Unlike JS, if we pass the incorrect amount of arguments to a function,</h1>
<h1 id="it-will-throw-an-error">it will throw an error</h1>
<h1 id="avg1-typeerror">avg(1) # TypeError</h1>
<h1 id="avg1-2-2-typeerror">avg(1, 2, 2) # TypeError</h1>
<h1 id="day-2--">———————————– DAY 2 —————————————-</h1>
<h1 id="functions---to-get-rest-of-position-arguments-as-tuple">Functions - * to get rest of position arguments as tuple</h1>
<h1 id="to-get-rest-of-keyword-arguments-as-a-dictionary">- ** to get rest of keyword arguments as a dictionary</h1>
<h1 id="variable-length-positional-arguments">Variable Length positional arguments</h1>
<p>def add(a, b, *args): # args is a tuple of the rest of the arguments total = a + b for n in args: total += n return total</p>
<p>print(add(1, 2)) # args is None, returns 3 print(add(1, 2, 3, 4, 5, 6)) # args is (3, 4, 5, 6), returns 21</p>
<h1 id="variable-length-keyword-arguments">Variable Length Keyword Arguments</h1>
<p>def print_names_and_countries(greeting, **kwargs): # kwargs is a dictionary of the rest of the keyword arguments for k, v in kwargs.items(): print(greeting, k, “from”, v)</p>
<p>print_names_and_countries( “Hey there”, Monica=“Sweden”, Mike=“The United States”, Mark=“China” )</p>
<h1 id="we-can-combine-all-of-these-together">We can combine all of these together</h1>
<p>def example2(arg1, arg2, *args, kw_1=“cheese”, kw_2=“horse”, **kwargs): pass</p>
<h1 id="lists-are-mutable-arrays">Lists are mutable arrays</h1>
<p>empty_list = [] roomates = [“Beau”, “Delynn”] # List built-in function makes a list too specials = list() # We can use ‘in’ to test if something is in the list, like ‘includes’ in JS print(1 in [1, 2, 4]) # True print(2 in [1, 3, 5]) # False</p>
<h1 id="dictionaries---similar-to-js-pojos-or-map-containing-key-value-pairs">Dictionaries - Similar to JS POJO’s or Map, containing key value pairs</h1>
<p>a = {“one”: 1, “two”: 2, “three”: 3} b = dict(one=1, two=2, three=3) # Can use ‘in’ on dictionaries too (for keys) print(“one” in a) # True print(3 in b) # False</p>
<h1 id="sets---just-like-js-unordered-collection-of-distinct-objects">Sets - Just like JS, unordered collection of distinct objects</h1>
<p>bedroom = {“bed”, “tv”, “computer”, “clothes”, “playstation 4”} # bedroom = set(“bed”, “tv”, “computer”, “clothes”, “playstation 5”) school_bag = set( [“book”, “paper”, “pencil”, “pencil”, “book”, “book”, “book”, “eraser”] ) print(school_bag) print(bedroom) # We can use ‘in’ on sets as wel print(1 in {1, 2, 3}) # True print(4 in {1, 3, 5}) # False</p>
<h1 id="tuples-are-immutable-lists-of-items">Tuples are immutable lists of items</h1>
<p>time_blocks = (“AM”, “PM”) colors = “red”, “green”, “blue” # Parenthesis not needed but encouraged # The tuple built-in function can be used to convert things to tuples print(tuple(“abc”)) print(tuple([1, 2, 3])) # ‘in’ may be used on tuples as well print(1 in (1, 2, 3)) # True print(5 in (1, 4, 3)) # False</p>
<h1 id="ranges-are-immutable-lists-of-numbers-often-used-with-for-loops">Ranges are immutable lists of numbers, often used with for loops</h1>
<h1 id="start---default-0-first-number-in-sequence">- start - default: 0, first number in sequence</h1>
<h1 id="stop---required-next-number-past-last-number-in-sequence">- stop - required, next number past last number in sequence</h1>
<h1 id="step---default-1-difference-between-each-number-in-sequence">- step - default: 1, difference between each number in sequence</h1>
<p>range1 = range(5) # [0,1,2,3,4] range2 = range(1, 5) # [1,2,3,4] range3 = range(0, 25, 5) # [0,5,10,15,20] range4 = range(0) # [] for i in range1: print(i)</p>
<h1 id="built-in-functions">Built-in functions:</h1>
<h1 id="filter">Filter</h1>
<p>isOdd = lambda num: num % 2 == 1</p>
<p>filtered = filter(isOdd, [1, 2, 3, 4]) print(list(filtered)) for num in filtered: print(f“first way: {num}”) print(“–” * 20) [print(f“list comprehension: {i}”) for i in [1, 2, 3, 4, 5, 6, 7, 8] if i % 2 == 1]</p>
<h1 id="map">Map</h1>
<p>def toUpper(str): return str.upper()</p>
<p>upperCased = map(toUpper, [“a”, “b”, “c”, “d”]) print(list(upperCased))</p>
<h1 id="sorted">Sorted</h1>
<p>sorted_items = sorted([“john”, “tom”, “sonny”, “Mike”]) print(list(sorted_items)) # Notice uppercase comes before lowercase # Using a key function to control the sorting and make it case insensitive sorted_items = sorted([“john”, “tom”, “sonny”, “Mike”], key=str.lower) print(sorted_items) # You can also reverse the sort sorted_items = sorted([“john”, “tom”, “sonny”, “Mike”], key=str.lower, reverse=True) print(sorted_items)</p>
<h1 id="enumerate-creates-a-tuple-with-an-index-for-what-youre-enumerating">Enumerate creates a tuple with an index for what you’re enumerating</h1>
<p>quarters = [“First”, “Second”, “Third”, “Fourth”] print(list(enumerate(quarters))) print(list(enumerate(quarters, start=1)))</p>
<h1 id="zip-takes-list-and-combines-them-as-key-value-pairs-or-really-however-you-need">Zip takes list and combines them as key value pairs, or really however you need</h1>
<p>keys = (“Name”, “Email”) values = (“Buster”, “cheetoh@johhnydepp.com”) zipped = zip(keys, values) print(list(zipped)) # You can zip more than 2 x_coords = [0, 1, 2, 3, 4] y_coords = [4, 6, 10, 9, 10] z_coords = [20, 10, 5, 9, 1] coords = zip(x_coords, y_coords, z_coords) print(list(coords))</p>
<h1 id="len-reports-the-length-of-strings-along-with-list-and-any-other-object-data-type">Len reports the length of strings along with list and any other object data type</h1>
<p>print_len = lambda item: print(len(item)) # doing this to save myself some typing</p>
<p>print_len(“Mike”) print_len([1, 5, 2, 10, 3, 10]) print_len({1, 5, 10, 9, 10}) # 4 because there is a duplicate here (10) print_len((1, 4, 10, 9, 20))</p>
<h1 id="max-will-return-the-max-number-in-a-given-scenario">Max will return the max number in a given scenario</h1>
<p>print(max(1, 2, 35, 1012, 1))</p>
<h1 id="min">Min</h1>
<p>print(min(1, 5, 2, 10)) print(min([1, 4, 7, 10]))</p>
<h1 id="sum">Sum</h1>
<p>print(sum([1, 2, 4]))</p>
<h1 id="any">Any</h1>
<p>print(any([True, False, False])) print(any([False, False, False]))</p>
<h1 id="all">All</h1>
<p>print(all([True, True, False])) print(all([True, True, True]))</p>
<h1 id="dir-returns-all-the-attributes-of-an-object-including-its-methods-and-dunder-methods">Dir returns all the attributes of an object including it’s methods and dunder methods</h1>
<p>user = {“Name”: “Bob”, “Email”: “bob@bob.com”} print(dir(user))</p>
<h1 id="importing-packages-and-modules">Importing packages and modules</h1>
<h1 id="module---a-python-code-in-a-file-or-directory">- Module - A Python code in a file or directory</h1>
<h1 id="package---a-module-which-is-a-directory-containing-an-init.py-file">- Package - A module which is a directory containing an <strong>init</strong>.py file</h1>
<h1 id="submodule---a-module-which-is-contained-within-a-package">- Submodule - A module which is contained within a package</h1>
<h1 id="name---an-exported-function-class-or-variable-in-a-module">- Name - An exported function, class, or variable in a module</h1>
<h1 id="unlike-js-modules-export-all-names-contained-within-them-without-any-special-export-key">Unlike JS, modules export ALL names contained within them without any special export key</h1>
<h1 id="assuming-we-have-the-following-package-with-four-submodules">Assuming we have the following package with four submodules</h1>
<h1 id="math">math</h1>
<h1 id="init.py">| <strong>init</strong>.py</h1>
<h1 id="addition.py">| addition.py</h1>
<h1 id="subtraction.py">| subtraction.py</h1>
<h1 id="multiplication.py">| multiplication.py</h1>
<h1 id="division.py">| division.py</h1>
<h1 id="if-we-peek-into-the-addition.py-file-we-see-theres-an-add-function">If we peek into the addition.py file we see there’s an add function</h1>
<h1 id="addition.py-1">addition.py</h1>
<h1 id="we-can-import-add-from-other-places-because-its-a-name-and-is-automatically-exported">We can import ‘add’ from other places because it’s a ‘name’ and is automatically exported</h1>
<p>def add(num1, num2): return num1 + num2</p>
<h1 id="notice-the-.-syntax-because-this-package-can-import-its-own-submodules.">Notice the . syntax because this package can import it’s own submodules.</h1>
<h1 id="our-init.py-has-the-following-files">Our <strong>init</strong>.py has the following files</h1>
<h1 id="this-imports-the-add-function">This imports the ‘add’ function</h1>
<h1 id="and-now-its-also-re-exported-in-here-as-well">And now it’s also re-exported in here as well</h1>
<h1 id="from-.addition-import-add">from .addition import add</h1>
<h1 id="these-import-and-re-export-the-rest-of-the-functions-from-the-submodule">These import and re-export the rest of the functions from the submodule</h1>
<h1 id="from-.subtraction-import-subtract">from .subtraction import subtract</h1>
<h1 id="from-.division-import-divide">from .division import divide</h1>
<h1 id="from-.multiplication-import-multiply">from .multiplication import multiply</h1>
<h1 id="so-if-we-have-a-script.py-and-want-to-import-add-we-could-do-it-many-ways">So if we have a script.py and want to import add, we could do it many ways</h1>
<h1 id="this-will-load-and-execute-the-mathinit.py-file-and-give">This will load and execute the ‘math/<strong>init</strong>.py’ file and give</h1>
<h1 id="us-an-object-with-the-exported-names-in-mathinit.py">us an object with the exported names in ‘math/<strong>init</strong>.py’</h1>
<p>import math</p>
<h1 id="printmath.add12">print(math.add(1,2))</h1>
<h1 id="this-imports-just-the-add-from-mathinit.py">This imports JUST the add from ‘math/<strong>init</strong>.py’</h1>
<h1 id="from-math-import-add">from math import add</h1>
<h1 id="printadd1-2">print(add(1, 2))</h1>
<h1 id="this-skips-importing-from-mathinit.py-although-it-still-runs">This skips importing from ‘math/<strong>init</strong>.py’ (although it still runs)</h1>
<h1 id="and-imports-directly-from-the-addition.py-file">and imports directly from the addition.py file</h1>
<h1 id="from-math.addition-import-add">from math.addition import add</h1>
<h1 id="this-imports-all-the-functions-individually-from-mathinit.py">This imports all the functions individually from ‘math/<strong>init</strong>.py’</h1>
<h1 id="from-math-import-add-subtract-multiply-divide">from math import add, subtract, multiply, divide</h1>
<h1 id="printadd1-2-1">print(add(1, 2))</h1>
<h1 id="printsubtract2-1">print(subtract(2, 1))</h1>
<h1 id="this-imports-add-renames-it-to-add_some_numbers">This imports ‘add’ renames it to ‘add_some_numbers’</h1>
<h1 id="from-math-import-add-as-add_some_numbers">from math import add as add_some_numbers</h1>
<h1 id="day-3">————————————— DAY 3 —————————————</h1>
<h1 id="classes-methods-and-properties">Classes, Methods, and Properties</h1>
<p>class AngryBird: # Slots optimize property access and memory usage and prevent you # from arbitrarily assigning new properties the instance <strong>slots</strong> = ["_x“,”_y"]</p>
<pre><code># Constructor
def __init__(self, x=0, y=0):
    # Doc String
    &quot;&quot;&quot;
    Construct a new AngryBird by setting it&#39;s position to (0, 0)
    &quot;&quot;&quot;
    ## Instance Variables
    self._x = x
    self._y = y

# Instance Method
def move_up_by(self, delta):
    self._y += delta

# Getter
@property
def x(self):
    return self._x

# Setter
@x.setter
def x(self, value):
    if value &lt; 0:
        value = 0
    self._x = value

@property
def y(self):
    return self._y

@y.setter
def y(self, value):
    self._y = value

# Dunder Repr... called by &#39;print&#39;
def __repr__(self):
    return f&quot;&lt;AngryBird ({self._x}, {self._y})&gt;&quot;</code></pre>
<h1 id="js-to-python-classes-cheat-table">JS to Python Classes cheat table</h1>
<h1 id="js-python">JS Python</h1>
<h1 id="constructor-def-initself">constructor() def <strong>init</strong>(self):</h1>
<h1 id="super-super.__init__-this.property-self.property-this.method-self.method-methodarg1-arg2-def-methodself-arg1-get-someproperty-property-set-someproperty-someproperty.setter">super() super().__init__() # this.property self.property # this.method self.method() # method(arg1, arg2){} def method(self, arg1, …) # get someProperty(){} <span class="citation" data-cites="property">@property</span> # set someProperty(){} <span class="citation" data-cites="someProperty.setter">@someProperty.setter</span></h1>
<h1 id="list-comprehensions-are-a-way-to-transform-a-list-from-one-format-to-another">List Comprehensions are a way to transform a list from one format to another</h1>
<h1 id="pythonic-alternative-to-using-map-or-filter">- Pythonic Alternative to using map or filter</h1>
<h1 id="syntax-of-a-list-comprehension">- Syntax of a list comprehension</h1>
<h1 id="new_list-value-loop-condition">- new_list = [value loop condition]</h1>
<h1 id="using-a-for-loop">Using a for loop</h1>
<p>squares = [] for i in range(10): squares.append(i ** 2) print(squares)</p>
<h1 id="value-i-2">value = i ** 2</h1>
<h1 id="loop-for-i-in-range10">loop = for i in range(10)</h1>
<p>squares = [i ** 2 for i in range(10)] print(list(squares))</p>
<p>sentence = “the rocket came back from mars” vowels = [character for character in sentence if character in “aeiou”] print(vowels)</p>
<h1 id="you-can-also-use-them-on-dictionaries.-we-can-use-the-items-method">You can also use them on dictionaries. We can use the items() method</h1>
<h1 id="for-the-dictionary-to-loop-through-it-getting-the-keys-and-values-out-at-once">for the dictionary to loop through it getting the keys and values out at once</h1>
<p>person = {“name”: “Corina”, “age”: 32, “height”: 1.4}</p>
<h1 id="this-loops-through-and-capitalizes-the-first-letter-of-all-keys">This loops through and capitalizes the first letter of all keys</h1>
<p>newPerson = {key.title(): value for key, value in person.items()} print(list(newPerson.items()))</p>
</body>
</html>
